/*
Okta Admin Management

Allows customers to easily access the Okta Management APIs

Copyright 2018 - Present Okta, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

API version: 2024.06.1
Contact: devex-public@okta.com
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.
package okta

import (
	"encoding/json"
)

// GovernanceBundleLinks struct for GovernanceBundleLinks
type GovernanceBundleLinks struct {
	Entitlements *HrefObject `json:"entitlements,omitempty"`
	AdditionalProperties map[string]interface{}
}

type _GovernanceBundleLinks GovernanceBundleLinks

// NewGovernanceBundleLinks instantiates a new GovernanceBundleLinks object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGovernanceBundleLinks() *GovernanceBundleLinks {
	this := GovernanceBundleLinks{}
	return &this
}

// NewGovernanceBundleLinksWithDefaults instantiates a new GovernanceBundleLinks object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGovernanceBundleLinksWithDefaults() *GovernanceBundleLinks {
	this := GovernanceBundleLinks{}
	return &this
}

// GetEntitlements returns the Entitlements field value if set, zero value otherwise.
func (o *GovernanceBundleLinks) GetEntitlements() HrefObject {
	if o == nil || o.Entitlements == nil {
		var ret HrefObject
		return ret
	}
	return *o.Entitlements
}

// GetEntitlementsOk returns a tuple with the Entitlements field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GovernanceBundleLinks) GetEntitlementsOk() (*HrefObject, bool) {
	if o == nil || o.Entitlements == nil {
		return nil, false
	}
	return o.Entitlements, true
}

// HasEntitlements returns a boolean if a field has been set.
func (o *GovernanceBundleLinks) HasEntitlements() bool {
	if o != nil && o.Entitlements != nil {
		return true
	}

	return false
}

// SetEntitlements gets a reference to the given HrefObject and assigns it to the Entitlements field.
func (o *GovernanceBundleLinks) SetEntitlements(v HrefObject) {
	o.Entitlements = &v
}

func (o GovernanceBundleLinks) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Entitlements != nil {
		toSerialize["entitlements"] = o.Entitlements
	}

	for key, value := range o.AdditionalProperties {
		toSerialize[key] = value
	}

	return json.Marshal(toSerialize)
}

func (o *GovernanceBundleLinks) UnmarshalJSON(bytes []byte) (err error) {
	varGovernanceBundleLinks := _GovernanceBundleLinks{}

	err = json.Unmarshal(bytes, &varGovernanceBundleLinks)
	if err == nil {
		*o = GovernanceBundleLinks(varGovernanceBundleLinks)
	} else {
		return err
	}

	additionalProperties := make(map[string]interface{})

	err = json.Unmarshal(bytes, &additionalProperties)
	if err == nil {
		delete(additionalProperties, "entitlements")
		o.AdditionalProperties = additionalProperties
	} else {
		return err
	}

	return err
}

type NullableGovernanceBundleLinks struct {
	value *GovernanceBundleLinks
	isSet bool
}

func (v NullableGovernanceBundleLinks) Get() *GovernanceBundleLinks {
	return v.value
}

func (v *NullableGovernanceBundleLinks) Set(val *GovernanceBundleLinks) {
	v.value = val
	v.isSet = true
}

func (v NullableGovernanceBundleLinks) IsSet() bool {
	return v.isSet
}

func (v *NullableGovernanceBundleLinks) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGovernanceBundleLinks(val *GovernanceBundleLinks) *NullableGovernanceBundleLinks {
	return &NullableGovernanceBundleLinks{value: val, isSet: true}
}

func (v NullableGovernanceBundleLinks) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGovernanceBundleLinks) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

